/* AuthorJournalTabViewController */

#import <Cocoa/Cocoa.h>

#import "accessDB.h"
#import "SourceTableView.h"
#import "LibraryViewController.h"
#import "SmartFavoriteView.h"
#import "SmartFavoriteController.h"
#import "FavoriteInfoController.h"
#import "ArticleSearchController.h"

@interface SourceController : NSObject
{
@private
	LibraryViewController* _libraryViewController;
	FavoriteInfoController* _favoriteInfoController;
	ArticleSearchController* _articleSearchController;
    IBOutlet NSView*			_SourceView;
    IBOutlet SourceTableView*	_SourceTable;
	IBOutlet SmartFavoriteController* _smartFavoriteController;
	int numberOfSmartFavorite;
	
    IBOutlet NSSearchField*	SearchField;

    NSBox*					_mainBox;

	NSSearchField*		_searchField;

    IBOutlet NSBox*			SourceBox;

    NSDrawer*		_drawer;

	NSTextField*			status;

	NSMutableArray* _sources;
	id movingSource;
}
- (void)initializeController;

- (void)loadFavorites;
- (void)setMainBox:(NSBox*)box;
- (NSView*)sourceView;
- (void)setDrawer:(NSDrawer*)d;
- (void)setSearchField:(NSSearchField*)s;

- (void)loadSmartFavorites;
- (void)saveSmartFavrite;
- (void)saveFavrite;

- (NSArray*)sources;
- (void)openSource:(int)selectedRow;

- (IBAction)clickOnSourceTable:(id)sender;
- (IBAction)addFavorite:(id)sender;
- (IBAction)deleteFavorite:(id)sender;
- (IBAction)renameFavorite:(id)sender;
- (IBAction)addSmartFavorite:(id)sender;
- (void)exportAsCSV:(id)sender;
- (void)exportAsEndNoteText:(id)sender;
- (void)exportAsBibTeX:(id)sender;
- (void)exportAsTheVancouverStyle:(id)sender;

- (void)search:(id)sender;
@end
